#include <stdio.h>
#include <stdlib.h>

/* Precompilerska direktiva; SEP ne treba kad se radi samo jedna grupa */
#define writeout_and_return(SEP, out, x, y, r) { int res = r; fprintf(out, "%d%c%d%c%d\n", x, SEP, y, SEP, res); return res; }

/* pomocne stvari */

#define mkabs(x) if (x < 0) x = -x;

int inv(int x) {
  int y = 0;
  mkabs(x);
  while (x) {
    y = 10 * y + x % 10;
    x /= 10;
  }
  return y;
}

int ds(int x, int b) {
  int sum = 0;
  mkabs(x);
  while (x) {
    sum += x % b;
    x /= b;
  }
  return sum;
}

int md(int x, int b) {
  int max = -1;
  mkabs(x);
  while (x) {
    int d = x % b;
    if (d > max) max = d;
    x /= b;
  }
  return max;
}

int has_digit(int x, int d) {
  mkabs(x);
  while (x) {
    if (x % 10 == 7) return 1;
    x /= 10;
  }
  return 0;
}

/* rjesenja zadataka */

int grupaA(FILE *out, int x, int y) {
  if (has_digit(x + y, 7)) writeout_and_return(';', out, x, y, x * y)
  if (x > inv(y)) writeout_and_return(';', out, x, y, grupaA(out, x + inv(y - 2 * x), x) + 7)
  writeout_and_return(';', out, x, y, grupaA(out, ds(x + y, 7), ds(x - y + 1, 7)))
}

int grupaB(FILE *out, int x, int y) {
  if (has_digit(x * y, 3)) writeout_and_return('#', out, x, y, x + y)
  if (inv(x) < y) writeout_and_return('#', out, x, y, grupaB(out, inv(x + y), y + 1) + 3)
  writeout_and_return('#', out, x, y, grupaB(out, md(x + y + 1, 17), md(x - y, 19)))
}

int grupaC(FILE *out, int x, int y) {
  if (has_digit(x * y, 5)) writeout_and_return('$', out, x, y, x - y)
  if (x < inv(y)) writeout_and_return('$', out, x, y, grupaC(out, inv(3 * y) + 1, x))
  writeout_and_return('$', out, x, y, grupaC(out, md(x + y + 1, 13), md(x - y, 23)))
}

int grupaD(FILE *out, int x, int y) {
  if (has_digit(x * y, 2)) writeout_and_return('|', out, x, y, x - y)
  if (inv(x) >= y) writeout_and_return('|', out, x, y, grupaD(out, x - 2, inv(2 * x - y)))
  writeout_and_return('|', out, x, y, grupaD(out, 2 * ds(x - y, 17), ds(x + y, 17)))
}

/* provjera */

int main(int argc, char *argv[]) {
  FILE *out;
  int x, y;

  if (argc < 2) {
    fprintf(stderr, "Poziv: %s x y\n", argv[0]);
    exit(1);
  }
  x = atoi(argv[1]);
  y = atoi(argv[2]);

  if ((out = fopen("recursion.txt", "wt")) == NULL) {
    fprintf(stderr, "Greska: ne mogu otvoriti file \"recursion.txt\" za pisanje.\n");
    exit(2);
  }

  printf("grupaA(%d, %d) = %d\n", x, y, grupaA(out, x, y));
  printf("grupaB(%d, %d) = %d\n", x, y, grupaB(out, x, y));
  printf("grupaC(%d, %d) = %d\n", x, y, grupaC(out, x, y));
  printf("grupaD(%d, %d) = %d\n", x, y, grupaD(out, x, y));
 
/* Masovno testiranje pojedinih poziva (dugo traje i producira veliki file!):
  fputs("Grupa A\n", out);
  for (x = -255; x < 256; ++x)
    for (y = -255; y < 256; ++y) {
      printf("Grupa A: x = %d, y = %d\n", x, y);
      fprintf(out, "x=%d;y=%d\n", x, y);
      grupaA(out, x, y);
    }

  fputs("Grupa B\n", out);
  for (x = -255; x < 256; ++x)
    for (y = -255; y < 256; ++y) {
      printf("Grupa B: x = %d, y = %d\n", x, y);
      fprintf(out, "x=%d#y=%d\n", x, y);
      grupaB(out, x, y);
    }

  fputs("Grupa C\n", out);
  for (x = -255; x < 256; ++x)
    for (y = -255; y < 256; ++y) {
      printf("Grupa C: x = %d, y = %d\n", x, y);
      fprintf(out, "x=%d$y=%d\n", x, y);
      grupaC(out, x, y);
    }

  fputs("Grupa D\n", out);
  for (x = -255; x < 256; ++x)
    for (y = -255; y < 256; ++y) {
      printf("Grupa D: x = %d, y = %d\n", x, y);
      fprintf(out, "x=%d|y=%d\n", x, y);
      grupaD(out, x, y);
    }
*/

  fclose(out);

  return 0;
}
