#include <stdio.h>
#include <stdlib.h>

void broj( char **A, int nRed, int nStup, int *brIznad, int *brIspod )
{
	int red, stup;
	
	*brIznad = *brIspod = 0;
	for( stup = 0; stup < nStup; ++stup )
	{
		int prosaoZid = 0; // jesam li presao zid u ovom stupcu?
		for( red = 0; red < nRed; ++red )
			if( A[ red ][ stup ] == '.' && !prosaoZid )
				++( *brIznad ); // jos nisam presao zid -> ova tocka je iznad zida
			else if( A[ red ][ stup ] == '.' && prosaoZid )
				++( *brIspod ); // vec sam presao zid -> ova tocka je ispod zida
			else // dakle, ovdje je A[ red ][ stup ] == '*' - upravo prelazim preko zida
				prosaoZid = 1;
	}
}

char *zid( char **A, int nRed, int nStup )
{
	int red, stup, trenPomak;
	char *opis;
	
	// broj pomaka = zbroj dimenzija matrice - 1; treba jos 1 znak za '\0'
	// alternativno: broj pomaka = broj zvjezdica u zidu - 1
	opis = ( char * ) malloc( ( nRed + nStup ) * sizeof( char ) );

	// simulacija nastanka zida: pocinjemo gore desno
	red = 0; stup = nStup - 1; trenPomak = 0;
	while( !( red == nRed - 1 && stup == 0 ) ) // i pomicemo se sve dok ne dodjemo dolje lijevo
	{
		if( red != nRed - 1 && A[ red + 1 ][ stup ] == '*' ) // jel iduca zvjezdica dolje?
			opis[ trenPomak++ ] = 'D', red = red + 1;
		else // ako iduca zvjezdica nije dolje, mora biti lijevo
			opis[ trenPomak++ ] = 'L', stup = stup - 1;
	}
	
	opis[ trenPomak ] = '\0';
	
	return opis;
}

int main( void )
{
	int nRed, nStup, red, stup, brIznad, brIspod;
	char **A, *opis;
	
	printf( "Broj redaka: " );  scanf( "%d", &nRed );
	printf( "Broj stupaca: " ); scanf( "%d", &nStup );
	
	A = ( char ** ) malloc( nRed * sizeof( char * ) );
	for( red = 0; red < nRed; ++red )
		A[ red ] = ( char * ) malloc( nStup * sizeof( char ) );
		
	printf( "Unesi matricu red po red:\n" );
	for( red = 0; red < nRed; ++red )
		for( stup = 0; stup < nStup; ++stup )
			scanf( " %c", &A[ red ][ stup ] );
			
	broj( A, nRed, nStup, &brIznad, &brIspod );
	printf( "\n\nIznad zida je %d, a ispod zida %d tocaka.\n", brIznad, brIspod );
	
	opis = zid( A, nRed, nStup );
	printf( "String koji opisuje nastanak zida: %s\n", opis );
		
	for( red = 0; red < nRed; ++red )
		free( A[ red ] );
	free( A );
	
	free( opis );
	
	return 0;
}
