#include <stdio.h>
#include <stdlib.h>

void broj( char **A, int nRed, int nStup, int *brLijevo, int *brDesno )
{
	int red, stup;
	
	*brLijevo = *brDesno = 0;
	for( red = 0; red < nRed; ++red )
	{
		int prosaoZid = 0; // jesam li presao zid u ovom retku?
		for( stup = 0; stup < nStup; ++stup )
			if( A[ red ][ stup ] == '.' && !prosaoZid )
				++( *brLijevo ); // jos nisam presao zid -> ova tocka je lijevo od zida
			else if( A[ red ][ stup ] == '.' && prosaoZid )
				++( *brDesno ); // vec sam presao zid -> ova tocka je desno od zida
			else // dakle, ovdje je A[ red ][ stup ] == '#' - upravo prelazim preko zida
				prosaoZid = 1;
	}
}

char *zid( char **A, int nRed, int nStup )
{
	int red, stup, trenPomak;
	char *opis;
	
	// broj pomaka = zbroj dimenzija matrice - 1; treba jos 1 znak za '\0'
	// alternativno: broj pomaka = broj povisilica u zidu - 1
	opis = ( char * ) malloc( ( nRed + nStup ) * sizeof( char ) );

	// simulacija nastanka zida: pocinjemo dolje lijevo
	red = nRed - 1; stup = 0; trenPomak = 0;
	while( !( red == 0 && stup == nStup - 1 ) ) // i pomicemo se sve dok ne dodjemo gore desno
	{
		if( red != 0 && A[ red - 1 ][ stup ] == '#' ) // jel iduca povisilica gore?
			opis[ trenPomak++ ] = 'G', red = red - 1;
		else // ako iduca zvjezdica nije gore, mora biti desno
			opis[ trenPomak++ ] = 'D', stup = stup + 1;
	}
	
	opis[ trenPomak ] = '\0';
	
	return opis;
}

int main( void )
{
	int nRed, nStup, red, stup, brLijevo, brDesno;
	char **A, *opis;
	
	printf( "Broj redaka: " );  scanf( "%d", &nRed );
	printf( "Broj stupaca: " ); scanf( "%d", &nStup );
	
	A = ( char ** ) malloc( nRed * sizeof( char * ) );
	for( red = 0; red < nRed; ++red )
		A[ red ] = ( char * ) malloc( nStup * sizeof( char ) );
		
	printf( "Unesi matricu red po red:\n" );
	for( red = 0; red < nRed; ++red )
		for( stup = 0; stup < nStup; ++stup )
			scanf( " %c", &A[ red ][ stup ] );
			
	broj( A, nRed, nStup, &brLijevo, &brDesno );
	printf( "\n\nLijevo od zida je %d, a desno od zida %d tocaka.\n", brLijevo, brDesno );
	
	opis = zid( A, nRed, nStup );
	printf( "String koji opisuje nastanak zida: %s\n", opis );
		
	for( red = 0; red < nRed; ++red )
		free( A[ red ] );
	free( A );
	
	free( opis );
	
	return 0;
}
