/* Popravni kolokvij iz Programiranja 2 2008/09. */
/* Zadatak 3, grupe A, B, C, D.                  */

#include <stdio.h>
#include <stdlib.h>

typedef struct _Zadatak {
  int sat, trajanje;
  char opis[32];
  struct _Zadatak *next;
} Zadatak;

typedef Zadatak* Rokovnik[4][7];


Zadatak *ubaci(Zadatak *first, Zadatak *novi) {
  Zadatak *tmp;
  if (!first)
    return novi;
  if (!novi)
    return first;
  if (novi->sat < first->sat) {
    novi->next = first;
    return novi;
  }
  for (tmp = first; tmp->next; tmp = tmp->next)
    if (novi->sat < tmp->next->sat)
      break;
  novi->next = tmp->next;
  tmp->next = novi;
  return first;
}


void Ac(Rokovnik rok, const int dan, const int sat) {
  div_t rs;
  Zadatak **first, *tmp;
  if (!rok)
    return;
  if ((dan < 1) || (dan > 28))
    return;
  if ((sat < 0) || (sat > 23))
    return;
  rs = div(dan - 1, 7);
  first = &(rok[rs.quot][rs.rem]);
  while (*first && ((*first)->sat <= sat) && ((*first)->trajanje <= 3)) {
    tmp = *first;
    *first = tmp->next;
    free(tmp);
  }
  if (!*first)
    return;
  for (tmp = *first; tmp->next; ) {
    if ((tmp->next->sat <= sat) && (tmp->next->trajanje <= 3)) {
      Zadatak *const pom = tmp->next;
      tmp->next = pom->next;
      free(pom);
    }
    else
      tmp = tmp->next;
  }
}


Zadatak *Ba(Zadatak *const first) {
  Zadatak *tmp;
  if (!first)
    return NULL;
  for (tmp = first; tmp->next; tmp = tmp->next)
    if (tmp->sat + tmp->trajanje > tmp->next->sat)
      return tmp;
  return NULL;
}


void Bc(Rokovnik rok, const int dan, const int sat) {
  div_t rs;
  Zadatak **first, *tmp;
  if (!rok)
    return;
  if ((dan < 1) || (dan > 28))
    return;
  if ((sat < 0) || (sat > 23))
    return;
  rs = div(dan - 1, 7);
  first = &(rok[rs.quot][rs.rem]);
  while (*first && ((*first)->sat >= sat) && ((*first)->trajanje >= 2)) {
    tmp = *first;
    *first = tmp->next;
    free(tmp);
  }
  if (!*first)
    return;
  for (tmp = *first; tmp->next; ) {
    if ((tmp->next->sat >= sat) && (tmp->next->trajanje >= 2)) {
      Zadatak *const pom = tmp->next;
      tmp->next = pom->next;
      free(pom);
    }
    else
      tmp = tmp->next;
  }
}


int Ca(const Zadatak *const first) {
  const Zadatak *tmp;
  if (!first)
    return 1;
  for (tmp = first; tmp->next; tmp = tmp->next)
    if (tmp->sat > tmp->next->sat)
      return 0;
  return 1;
}


void delAll(Zadatak **first) {
  Zadatak *tmp, *pom;
  if (!first)
    return;
  for (tmp = *first; tmp; tmp = pom) {
    pom = tmp->next;
    free(tmp);
  }
  *first = NULL;
}


void Cc(Rokovnik rok, const int dan, const int norma) {
  int tjedan;
  if (!rok)
    return;
  if ((dan < 1) || (dan > 7))
    return;
  if ((norma < 0) || (norma > 24))
    return;
  for (tjedan = 0; tjedan < 4; ++tjedan) {
    int suma;
    Zadatak *tmp, **first = &(rok[tjedan][dan - 1]);
    if (!*first)
      continue;
    if ((suma = (*first)->trajanje) > norma) {
      delAll(first);
      continue;
    }
    for (tmp = *first; tmp->next; tmp = tmp->next)
      if ((suma += tmp->next->trajanje) > norma) {
	delAll(&(tmp->next));
	break;
      }
  }
}


int Da(const Zadatak *const first) {
  const Zadatak *tmp;
  int suma = 0;
  for (tmp = first; tmp; tmp = tmp->next)
    suma += tmp->trajanje;
  return (suma > 24) ? -1 : suma;
}


void Dd(Rokovnik rok, const int tjedan, const int norma) {
  int dan, suma = 0;
  if (!rok)
    return;
  if ((tjedan < 1) || (tjedan > 4))
    return;
  if ((norma < 0) || (norma > 168))
    return;
  for (dan = 0; dan < 7; ++dan) {
    Zadatak *tmp, **first = &(rok[tjedan - 1][dan]);
    if (!*first)
      continue;
    if ((suma += (*first)->trajanje) > norma) {
      delAll(first);
      break;
    }
    for (tmp = *first; tmp->next; tmp = tmp->next)
      if ((suma += tmp->next->trajanje) > norma) {
	delAll(&(tmp->next));
	goto cistac;
      }
  }
 cistac:
  for (++dan; dan < 7; ++dan)
    delAll(&(rok[tjedan - 1][dan]));
}


int main() {
  return EXIT_SUCCESS;
}
